let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  perl = "/nix/store/0394561gzxpyr6xv1mzwms2xlq1l24qi-perl-5.24.3/bin/perl";
  shell = "/nix/store/dmfz544hj5z7zsahrl916426aksfnpd9-bash-4.4-p12/bin/bash";
  coreutils = "/nix/store/lwq12kjcy8m40s3f00wgjdmr0gxq995l-coreutils-8.28/bin";
  bzip2 = "/nix/store/937vgincdvnhz71pyjjj6blbppfxgfj8-bzip2-1.0.6.0.1-bin/bin/bzip2";
  gzip = "/nix/store/nq7j1jk69rs4rww0zgyqgcsj9b750b85-gzip-1.8/bin/gzip";
  xz = "/nix/store/xpz3vxfh0yh3bj5grhx0c2lqm8za4hav-xz-5.2.3-bin/bin/xz";
  tar = "/nix/store/lrp4xnizm2jqwzil8z8ik3fwxniyrri0-gnutar-1.29/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/lwq12kjcy8m40s3f00wgjdmr0gxq995l-coreutils-8.28/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/hwpp7kia2f0in5ns2hiw41q38k30jpj2-nix-1.11.16/bin";
  nixPrefix = "/nix/store/hwpp7kia2f0in5ns2hiw41q38k30jpj2-nix-1.11.16";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
